<h1>Your Gitlab raw activity / events</h1>

<rm-spinner *ngIf="isLoading"></rm-spinner>

<ng-container *ngIf="!isLoading">
  <ng-container *ngIf="gitlabEvents.length > 0 && gitlabProjects.length > 0; else noContent;">
    <app-events-list [projects]="gitlabProjects" [events]="gitlabEvents"></app-events-list>  
  </ng-container>
  
  <ng-template #noContent>
    <ng-container *ngIf="hasAccessToken">
      <p>Sorry, there seems to be an issue fetching your activity...</p>
    </ng-container>
  
    <ng-container *ngIf="!hasAccessToken">
      <p>It seems you are not authenticated with Gitlab. Please log into your Gitlab account:</p>
      <button rm-button rmType="primary" (click)="didPressLogintoGithub()">Log in to Gitlab</button>
    </ng-container>
  </ng-template>
  
  <!-- configuration -->
  <ng-container *ngIf="(gitlabProjects.length > 0)">
  
    <div class="rm-configuration-wrapper">
      <h1>Your configuration:</h1>
      <p>I've found some projects you're working on Gitlab:</p>
      <div>
        <small>If there are any assignments for this week in regards to PROAD milestones / projects, I will auto-fill the inputs besides them. <br /> You can and should change the milestone on a weekly basis depending on what you are working on.</small>
      </div>
      <br />
      <br />
      <div class="rm-project-configuration" *ngIf="projectsForm" [formGroup]="projectsForm">
        <div class="rm-project" *ngFor="let project of gitlabProjects">
          <div class="rm-project-meta">
            <span class="rm-project-repo">{{ project?.name}}</span>
            <span class="rm-project-name">{{ project?.name_with_namespace}}</span>
          </div>
          <div class="rm-project-proad-configuration">
            <rm-form-field>
              <label *ngIf="getProadMilestoneFromProjectId(project?.id!)" rm-form-field-label for="username">PROAD project / milestone</label>
              <input rm-input [formControlName]="project?.id!"  />
            </rm-form-field>
          </div>
        </div>
      </div>
    </div>
  
    <div class="rm-actions">
      <button rm-button rmType="primary" (click)="didPressUpdateConfiguration()">Update configuration</button>
    </div>
  </ng-container>
  <!-- /configuration -->
  
  
  <!-- project map table - this will be a 5 column table containing project ids and an input for time spend -->
  <ng-container *ngIf="(gitlabProjects.length > 0)">
    <h1>Your weekly work per project map</h1>
    
    <div class="rm-row">
      <div class="rm-col-sm-6">
        <form [formGroup]="dateRangeForm">
          <rm-form-field ruvStyle="new">
            <label ruv-form-field-label>Specified range</label>
            <rm-form-field-control errorTip="Required Field">
                <rm-date-range-picker [iconPosition]="'right'" [rmAllowClear]="true" formControlName="dates"></rm-date-range-picker>
            </rm-form-field-control>
          </rm-form-field>
        </form>
      </div>
    </div>
  
    <div class="rm-project-weekly-distribution" *ngIf="form" [formGroup]="form">
      <div class="rm-project-weekday" *ngFor="let weekday of hardCodedWeekdays">
        <div class="rm-label"><span rm-tooltip [tooltipTitle]="(getDateForWeekDayForCurrentRange(weekday.dayOfWeek) | date:'yyyy.MM.dd')!">{{ weekday.label }}</span></div>
        <div class="rm-projects-listing">
          <ng-container *ngFor="let project of getProjectsWorkedOnWeekday(weekday.dayOfWeek); let i = index;" [formArrayName]="weekday.dayOfWeek">
            <div class="rm-project" [formGroupName]="i">
              <div class="rm-project-meta">
                <span class="rm-project-name" (click)="didPressProjectActivityForWeekday(project, weekday.dayOfWeek)">{{ project?.name }}</span>
                <span class="rm-project-proad-milestone">{{ getProadMilestoneFromProjectId(project?.id!) }}</span>
              </div>
              <div class="rm-project-input">
                <rm-form-field>
                  <rm-form-field-control>
                      <input maxlength="2" type="number" rm-input rm-input-numeric formControlName="input" max="24" />
                  </rm-form-field-control>
                </rm-form-field>
              </div>
            </div>
          </ng-container>
        </div>
      </div>
  
    </div>
  
    <div class="rm-actions">
      <br />
      <button rm-button rmType="primary" (click)="didPressPrepareData()">Prepare for PROAD</button>&nbsp;
    </div>
  
  
    <div class="rm-project-week-breakdown">
      <div class="rm-totals rm-row">
  
      <div class="rm-totals-per-weekday rm-col-xs-12 rm-col-sm-6">
        <h2>Totals per weekday</h2>
        <table>
          <tr>
            <th>Weekday</th>
            <th>Time Spent</th>
          </tr>
          <tr *ngFor="let weekday of hardCodedWeekdays">
            <td><strong>{{ weekday.label }}</strong></td>
            <td>
              <div class="projects" *ngFor="let project of getProjectsWorkedOnWeekday(weekday.dayOfWeek)">
                <div class="project-meta">
                  <div class="project-name">{{project?.name}}</div>
                  <div class="project-proad-code">{{getProadMilestoneFromProjectId(project?.id!)}}</div>
                </div>
                <div class="project-time">{{getHoursSpentForProjectOnWeekday(project?.id!, weekday.dayOfWeek)}}</div>
              </div>
            </td>
          </tr>
        </table>
      </div>
  
      <div class="rm-totals-per-project rm-col-xs-12 rm-col-sm-6">
        <h2>Totals per project</h2>
  
        <table>
          <tr>
            <th>Project</th>
            <th>Time Spent</th>
          </tr>
          <tr class="project" *ngFor="let project of gitlabProjects">
            <td>
              <div class="project-meta">
                <div class="project-name">{{ project?.name }}</div>
                <div class="project-proad-code">{{ getProadMilestoneFromProjectId(project?.id!) }}</div>
              </div>
            </td>
            <td><div class="project-time">{{ getTotalHoursSpendForProjectOnWeek(project?.id!) }}</div></td>
          </tr>
        </table>
      </div>
      </div>
    </div>
  
  </ng-container>
</ng-container>